/**
 */
package org.pnml.emf.ptnet.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import org.pnml.emf.ptnet.Arc;
import org.pnml.emf.ptnet.InhibitorArc;
import org.pnml.emf.ptnet.Page;
import org.pnml.emf.ptnet.PetriNet;
import org.pnml.emf.ptnet.Place;
import org.pnml.emf.ptnet.PtnetPackage;
import org.pnml.emf.ptnet.ReadArc;
import org.pnml.emf.ptnet.RefPlace;
import org.pnml.emf.ptnet.RefTransition;
import org.pnml.emf.ptnet.ToolInfoPage;
import org.pnml.emf.ptnet.Transition;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Page</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link org.pnml.emf.ptnet.impl.PageImpl#getArc <em>Arc</em>}</li>
 *   <li>{@link org.pnml.emf.ptnet.impl.PageImpl#getContainerPetriNet <em>Container Petri Net</em>}</li>
 *   <li>{@link org.pnml.emf.ptnet.impl.PageImpl#getPlace <em>Place</em>}</li>
 *   <li>{@link org.pnml.emf.ptnet.impl.PageImpl#getTransition <em>Transition</em>}</li>
 *   <li>{@link org.pnml.emf.ptnet.impl.PageImpl#getPage <em>Page</em>}</li>
 *   <li>{@link org.pnml.emf.ptnet.impl.PageImpl#getContainerPage <em>Container Page</em>}</li>
 *   <li>{@link org.pnml.emf.ptnet.impl.PageImpl#getReferencePlace <em>Reference Place</em>}</li>
 *   <li>{@link org.pnml.emf.ptnet.impl.PageImpl#getReferenceTransition <em>Reference Transition</em>}</li>
 *   <li>{@link org.pnml.emf.ptnet.impl.PageImpl#getReadArc <em>Read Arc</em>}</li>
 *   <li>{@link org.pnml.emf.ptnet.impl.PageImpl#getInhibitorArc <em>Inhibitor Arc</em>}</li>
 *   <li>{@link org.pnml.emf.ptnet.impl.PageImpl#getToolspecific <em>Toolspecific</em>}</li>
 * </ul>
 *
 * @generated
 */
public class PageImpl extends PositionableObjectImpl implements Page {
   /**
    * The cached value of the '{@link #getArc() <em>Arc</em>}' containment reference list.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getArc()
    * @generated
    * @ordered
    */
   protected EList<Arc> arc;

   /**
    * The cached value of the '{@link #getPlace() <em>Place</em>}' containment reference list.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getPlace()
    * @generated
    * @ordered
    */
   protected EList<Place> place;

   /**
    * The cached value of the '{@link #getTransition() <em>Transition</em>}' containment reference list.
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @see #getTransition()
    * @generated
    * @ordered
    */
   protected EList<Transition> transition;

   /**
    * The cached value of the '{@link #getPage() <em>Page</em>}' containment reference list.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getPage()
    * @generated
    * @ordered
    */
   protected EList<Page> page;

   /**
    * The cached value of the '{@link #getReferencePlace() <em>Reference Place</em>}' containment reference list.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getReferencePlace()
    * @generated
    * @ordered
    */
   protected EList<RefPlace> referencePlace;

   /**
    * The cached value of the '{@link #getReferenceTransition() <em>Reference Transition</em>}' containment reference list.
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @see #getReferenceTransition()
    * @generated
    * @ordered
    */
   protected EList<RefTransition> referenceTransition;

   /**
    * The cached value of the '{@link #getReadArc() <em>Read Arc</em>}' containment reference list.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getReadArc()
    * @generated
    * @ordered
    */
   protected EList<ReadArc> readArc;

   /**
    * The cached value of the '{@link #getInhibitorArc() <em>Inhibitor Arc</em>}' containment reference list.
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @see #getInhibitorArc()
    * @generated
    * @ordered
    */
   protected EList<InhibitorArc> inhibitorArc;

   /**
    * The cached value of the '{@link #getToolspecific() <em>Toolspecific</em>}' containment reference list.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getToolspecific()
    * @generated
    * @ordered
    */
   protected EList<ToolInfoPage> toolspecific;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected PageImpl() {
      super();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   protected EClass eStaticClass() {
      return PtnetPackage.Literals.PAGE;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EList<Arc> getArc() {
      if (arc == null) {
         arc = new EObjectContainmentWithInverseEList<Arc>(Arc.class, this, PtnetPackage.PAGE__ARC,
            PtnetPackage.ARC__CONTAINER_PAGE);
      }
      return arc;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public PetriNet getContainerPetriNet() {
      if (eContainerFeatureID() != PtnetPackage.PAGE__CONTAINER_PETRI_NET)
         return null;
      return (PetriNet) eInternalContainer();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public NotificationChain basicSetContainerPetriNet(PetriNet newContainerPetriNet, NotificationChain msgs) {
      msgs = eBasicSetContainer((InternalEObject) newContainerPetriNet, PtnetPackage.PAGE__CONTAINER_PETRI_NET, msgs);
      return msgs;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public void setContainerPetriNet(PetriNet newContainerPetriNet) {
      if (newContainerPetriNet != eInternalContainer()
         || (eContainerFeatureID() != PtnetPackage.PAGE__CONTAINER_PETRI_NET && newContainerPetriNet != null)) {
         if (EcoreUtil.isAncestor(this, newContainerPetriNet))
            throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
         NotificationChain msgs = null;
         if (eInternalContainer() != null)
            msgs = eBasicRemoveFromContainer(msgs);
         if (newContainerPetriNet != null)
            msgs = ((InternalEObject) newContainerPetriNet).eInverseAdd(this, PtnetPackage.PETRI_NET__PAGE,
               PetriNet.class, msgs);
         msgs = basicSetContainerPetriNet(newContainerPetriNet, msgs);
         if (msgs != null)
            msgs.dispatch();
      } else if (eNotificationRequired())
         eNotify(new ENotificationImpl(this, Notification.SET, PtnetPackage.PAGE__CONTAINER_PETRI_NET,
            newContainerPetriNet, newContainerPetriNet));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EList<Place> getPlace() {
      if (place == null) {
         place = new EObjectContainmentWithInverseEList<Place>(Place.class, this, PtnetPackage.PAGE__PLACE,
            PtnetPackage.PLACE__CONTAINER_PAGE);
      }
      return place;
   }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EList<Transition> getTransition() {
      if (transition == null) {
         transition = new EObjectContainmentWithInverseEList<Transition>(Transition.class, this,
            PtnetPackage.PAGE__TRANSITION, PtnetPackage.TRANSITION__CONTAINER_PAGE);
      }
      return transition;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EList<Page> getPage() {
      if (page == null) {
         page = new EObjectContainmentWithInverseEList<Page>(Page.class, this, PtnetPackage.PAGE__PAGE,
            PtnetPackage.PAGE__CONTAINER_PAGE);
      }
      return page;
   }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Page getContainerPage() {
      if (eContainerFeatureID() != PtnetPackage.PAGE__CONTAINER_PAGE)
         return null;
      return (Page) eInternalContainer();
   }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   public NotificationChain basicSetContainerPage(Page newContainerPage, NotificationChain msgs) {
      msgs = eBasicSetContainer((InternalEObject) newContainerPage, PtnetPackage.PAGE__CONTAINER_PAGE, msgs);
      return msgs;
   }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public void setContainerPage(Page newContainerPage) {
      if (newContainerPage != eInternalContainer()
         || (eContainerFeatureID() != PtnetPackage.PAGE__CONTAINER_PAGE && newContainerPage != null)) {
         if (EcoreUtil.isAncestor(this, newContainerPage))
            throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
         NotificationChain msgs = null;
         if (eInternalContainer() != null)
            msgs = eBasicRemoveFromContainer(msgs);
         if (newContainerPage != null)
            msgs = ((InternalEObject) newContainerPage).eInverseAdd(this, PtnetPackage.PAGE__PAGE, Page.class, msgs);
         msgs = basicSetContainerPage(newContainerPage, msgs);
         if (msgs != null)
            msgs.dispatch();
      } else if (eNotificationRequired())
         eNotify(new ENotificationImpl(this, Notification.SET, PtnetPackage.PAGE__CONTAINER_PAGE, newContainerPage,
            newContainerPage));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EList<RefPlace> getReferencePlace() {
      if (referencePlace == null) {
         referencePlace = new EObjectContainmentWithInverseEList<RefPlace>(RefPlace.class, this,
            PtnetPackage.PAGE__REFERENCE_PLACE, PtnetPackage.REF_PLACE__CONTAINER_PAGE);
      }
      return referencePlace;
   }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EList<RefTransition> getReferenceTransition() {
      if (referenceTransition == null) {
         referenceTransition = new EObjectContainmentWithInverseEList<RefTransition>(RefTransition.class, this,
            PtnetPackage.PAGE__REFERENCE_TRANSITION, PtnetPackage.REF_TRANSITION__CONTAINER_PAGE);
      }
      return referenceTransition;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EList<ReadArc> getReadArc() {
      if (readArc == null) {
         readArc = new EObjectContainmentWithInverseEList<ReadArc>(ReadArc.class, this, PtnetPackage.PAGE__READ_ARC,
            PtnetPackage.READ_ARC__CONTAINER_PAGE);
      }
      return readArc;
   }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EList<InhibitorArc> getInhibitorArc() {
      if (inhibitorArc == null) {
         inhibitorArc = new EObjectContainmentWithInverseEList<InhibitorArc>(InhibitorArc.class, this,
            PtnetPackage.PAGE__INHIBITOR_ARC, PtnetPackage.INHIBITOR_ARC__PAGE);
      }
      return inhibitorArc;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EList<ToolInfoPage> getToolspecific() {
      if (toolspecific == null) {
         toolspecific = new EObjectContainmentWithInverseEList<ToolInfoPage>(ToolInfoPage.class, this,
            PtnetPackage.PAGE__TOOLSPECIFIC, PtnetPackage.TOOL_INFO_PAGE__PAGE);
      }
      return toolspecific;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @SuppressWarnings("unchecked")
   @Override
   public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
      switch (featureID) {
         case PtnetPackage.PAGE__ARC:
            return ((InternalEList<InternalEObject>) (InternalEList<?>) getArc()).basicAdd(otherEnd, msgs);
         case PtnetPackage.PAGE__CONTAINER_PETRI_NET:
            if (eInternalContainer() != null)
               msgs = eBasicRemoveFromContainer(msgs);
            return basicSetContainerPetriNet((PetriNet) otherEnd, msgs);
         case PtnetPackage.PAGE__PLACE:
            return ((InternalEList<InternalEObject>) (InternalEList<?>) getPlace()).basicAdd(otherEnd, msgs);
         case PtnetPackage.PAGE__TRANSITION:
            return ((InternalEList<InternalEObject>) (InternalEList<?>) getTransition()).basicAdd(otherEnd, msgs);
         case PtnetPackage.PAGE__PAGE:
            return ((InternalEList<InternalEObject>) (InternalEList<?>) getPage()).basicAdd(otherEnd, msgs);
         case PtnetPackage.PAGE__CONTAINER_PAGE:
            if (eInternalContainer() != null)
               msgs = eBasicRemoveFromContainer(msgs);
            return basicSetContainerPage((Page) otherEnd, msgs);
         case PtnetPackage.PAGE__REFERENCE_PLACE:
            return ((InternalEList<InternalEObject>) (InternalEList<?>) getReferencePlace()).basicAdd(otherEnd, msgs);
         case PtnetPackage.PAGE__REFERENCE_TRANSITION:
            return ((InternalEList<InternalEObject>) (InternalEList<?>) getReferenceTransition()).basicAdd(otherEnd,
               msgs);
         case PtnetPackage.PAGE__READ_ARC:
            return ((InternalEList<InternalEObject>) (InternalEList<?>) getReadArc()).basicAdd(otherEnd, msgs);
         case PtnetPackage.PAGE__INHIBITOR_ARC:
            return ((InternalEList<InternalEObject>) (InternalEList<?>) getInhibitorArc()).basicAdd(otherEnd, msgs);
         case PtnetPackage.PAGE__TOOLSPECIFIC:
            return ((InternalEList<InternalEObject>) (InternalEList<?>) getToolspecific()).basicAdd(otherEnd, msgs);
      }
      return super.eInverseAdd(otherEnd, featureID, msgs);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
      switch (featureID) {
         case PtnetPackage.PAGE__ARC:
            return ((InternalEList<?>) getArc()).basicRemove(otherEnd, msgs);
         case PtnetPackage.PAGE__CONTAINER_PETRI_NET:
            return basicSetContainerPetriNet(null, msgs);
         case PtnetPackage.PAGE__PLACE:
            return ((InternalEList<?>) getPlace()).basicRemove(otherEnd, msgs);
         case PtnetPackage.PAGE__TRANSITION:
            return ((InternalEList<?>) getTransition()).basicRemove(otherEnd, msgs);
         case PtnetPackage.PAGE__PAGE:
            return ((InternalEList<?>) getPage()).basicRemove(otherEnd, msgs);
         case PtnetPackage.PAGE__CONTAINER_PAGE:
            return basicSetContainerPage(null, msgs);
         case PtnetPackage.PAGE__REFERENCE_PLACE:
            return ((InternalEList<?>) getReferencePlace()).basicRemove(otherEnd, msgs);
         case PtnetPackage.PAGE__REFERENCE_TRANSITION:
            return ((InternalEList<?>) getReferenceTransition()).basicRemove(otherEnd, msgs);
         case PtnetPackage.PAGE__READ_ARC:
            return ((InternalEList<?>) getReadArc()).basicRemove(otherEnd, msgs);
         case PtnetPackage.PAGE__INHIBITOR_ARC:
            return ((InternalEList<?>) getInhibitorArc()).basicRemove(otherEnd, msgs);
         case PtnetPackage.PAGE__TOOLSPECIFIC:
            return ((InternalEList<?>) getToolspecific()).basicRemove(otherEnd, msgs);
      }
      return super.eInverseRemove(otherEnd, featureID, msgs);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
      switch (eContainerFeatureID()) {
         case PtnetPackage.PAGE__CONTAINER_PETRI_NET:
            return eInternalContainer().eInverseRemove(this, PtnetPackage.PETRI_NET__PAGE, PetriNet.class, msgs);
         case PtnetPackage.PAGE__CONTAINER_PAGE:
            return eInternalContainer().eInverseRemove(this, PtnetPackage.PAGE__PAGE, Page.class, msgs);
      }
      return super.eBasicRemoveFromContainerFeature(msgs);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Object eGet(int featureID, boolean resolve, boolean coreType) {
      switch (featureID) {
         case PtnetPackage.PAGE__ARC:
            return getArc();
         case PtnetPackage.PAGE__CONTAINER_PETRI_NET:
            return getContainerPetriNet();
         case PtnetPackage.PAGE__PLACE:
            return getPlace();
         case PtnetPackage.PAGE__TRANSITION:
            return getTransition();
         case PtnetPackage.PAGE__PAGE:
            return getPage();
         case PtnetPackage.PAGE__CONTAINER_PAGE:
            return getContainerPage();
         case PtnetPackage.PAGE__REFERENCE_PLACE:
            return getReferencePlace();
         case PtnetPackage.PAGE__REFERENCE_TRANSITION:
            return getReferenceTransition();
         case PtnetPackage.PAGE__READ_ARC:
            return getReadArc();
         case PtnetPackage.PAGE__INHIBITOR_ARC:
            return getInhibitorArc();
         case PtnetPackage.PAGE__TOOLSPECIFIC:
            return getToolspecific();
      }
      return super.eGet(featureID, resolve, coreType);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @SuppressWarnings("unchecked")
   @Override
   public void eSet(int featureID, Object newValue) {
      switch (featureID) {
         case PtnetPackage.PAGE__ARC:
            getArc().clear();
            getArc().addAll((Collection<? extends Arc>) newValue);
            return;
         case PtnetPackage.PAGE__CONTAINER_PETRI_NET:
            setContainerPetriNet((PetriNet) newValue);
            return;
         case PtnetPackage.PAGE__PLACE:
            getPlace().clear();
            getPlace().addAll((Collection<? extends Place>) newValue);
            return;
         case PtnetPackage.PAGE__TRANSITION:
            getTransition().clear();
            getTransition().addAll((Collection<? extends Transition>) newValue);
            return;
         case PtnetPackage.PAGE__PAGE:
            getPage().clear();
            getPage().addAll((Collection<? extends Page>) newValue);
            return;
         case PtnetPackage.PAGE__CONTAINER_PAGE:
            setContainerPage((Page) newValue);
            return;
         case PtnetPackage.PAGE__REFERENCE_PLACE:
            getReferencePlace().clear();
            getReferencePlace().addAll((Collection<? extends RefPlace>) newValue);
            return;
         case PtnetPackage.PAGE__REFERENCE_TRANSITION:
            getReferenceTransition().clear();
            getReferenceTransition().addAll((Collection<? extends RefTransition>) newValue);
            return;
         case PtnetPackage.PAGE__READ_ARC:
            getReadArc().clear();
            getReadArc().addAll((Collection<? extends ReadArc>) newValue);
            return;
         case PtnetPackage.PAGE__INHIBITOR_ARC:
            getInhibitorArc().clear();
            getInhibitorArc().addAll((Collection<? extends InhibitorArc>) newValue);
            return;
         case PtnetPackage.PAGE__TOOLSPECIFIC:
            getToolspecific().clear();
            getToolspecific().addAll((Collection<? extends ToolInfoPage>) newValue);
            return;
      }
      super.eSet(featureID, newValue);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public void eUnset(int featureID) {
      switch (featureID) {
         case PtnetPackage.PAGE__ARC:
            getArc().clear();
            return;
         case PtnetPackage.PAGE__CONTAINER_PETRI_NET:
            setContainerPetriNet((PetriNet) null);
            return;
         case PtnetPackage.PAGE__PLACE:
            getPlace().clear();
            return;
         case PtnetPackage.PAGE__TRANSITION:
            getTransition().clear();
            return;
         case PtnetPackage.PAGE__PAGE:
            getPage().clear();
            return;
         case PtnetPackage.PAGE__CONTAINER_PAGE:
            setContainerPage((Page) null);
            return;
         case PtnetPackage.PAGE__REFERENCE_PLACE:
            getReferencePlace().clear();
            return;
         case PtnetPackage.PAGE__REFERENCE_TRANSITION:
            getReferenceTransition().clear();
            return;
         case PtnetPackage.PAGE__READ_ARC:
            getReadArc().clear();
            return;
         case PtnetPackage.PAGE__INHIBITOR_ARC:
            getInhibitorArc().clear();
            return;
         case PtnetPackage.PAGE__TOOLSPECIFIC:
            getToolspecific().clear();
            return;
      }
      super.eUnset(featureID);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public boolean eIsSet(int featureID) {
      switch (featureID) {
         case PtnetPackage.PAGE__ARC:
            return arc != null && !arc.isEmpty();
         case PtnetPackage.PAGE__CONTAINER_PETRI_NET:
            return getContainerPetriNet() != null;
         case PtnetPackage.PAGE__PLACE:
            return place != null && !place.isEmpty();
         case PtnetPackage.PAGE__TRANSITION:
            return transition != null && !transition.isEmpty();
         case PtnetPackage.PAGE__PAGE:
            return page != null && !page.isEmpty();
         case PtnetPackage.PAGE__CONTAINER_PAGE:
            return getContainerPage() != null;
         case PtnetPackage.PAGE__REFERENCE_PLACE:
            return referencePlace != null && !referencePlace.isEmpty();
         case PtnetPackage.PAGE__REFERENCE_TRANSITION:
            return referenceTransition != null && !referenceTransition.isEmpty();
         case PtnetPackage.PAGE__READ_ARC:
            return readArc != null && !readArc.isEmpty();
         case PtnetPackage.PAGE__INHIBITOR_ARC:
            return inhibitorArc != null && !inhibitorArc.isEmpty();
         case PtnetPackage.PAGE__TOOLSPECIFIC:
            return toolspecific != null && !toolspecific.isEmpty();
      }
      return super.eIsSet(featureID);
   }

} //PageImpl
