package org.eclipse.glsp.example.javaemf.Simulation;

import jakarta.inject.Inject;
import org.eclipse.emf.common.command.Command;
import org.eclipse.emf.common.command.CompoundCommand;
import org.eclipse.glsp.example.javaemf.model.ExtendedModelState;
import org.eclipse.glsp.server.emf.EMFOperationHandler;

import java.util.Optional;

public class ResetMarkingsOperationHandler extends EMFOperationHandler<ResetMarkingsOperation> {
    @Inject
    ExtendedModelState modelState;

    @Override
    public Optional<Command> createCommand(ResetMarkingsOperation resetMarkingsOperation) {
        modelState.getSimulationMarking().clear();
        return Optional.of(new CompoundCommand());
    }
}
