package org.eclipse.glsp.example.javaemf.handler.EdgeAndRefCreation;

import org.eclipse.glsp.example.javaemf.PNMLModelTypes;
import org.pnml.emf.ptnet.*;

public class CreateInhibitorArcHandler extends CreateArcHandler {

    public CreateInhibitorArcHandler() {
        super(PNMLModelTypes.INHIBITOR_ARC);
    }


    @Override
    public String getLabel() { return "InhibitorArc"; }


    protected void setType(Arc arc){
        ToolInfo arcToolSpecifics = PtnetFactory.eINSTANCE.createToolInfo();
        arcToolSpecifics.setTool(PNMLModelTypes.DINEROS_TOOL_NAME);
        arcToolSpecifics.setVersion(PNMLModelTypes.DINEROS_VERSION);
        arcToolSpecifics.setType(PNMLModelTypes.INHIBITOR_ARC_TYPE);
        arc.getToolspecific().add(arcToolSpecifics);
    }

}
