package org.eclipse.glsp.example.javaemf.handler.EdgeAndRefCreation;

import org.eclipse.glsp.example.javaemf.PNMLModelTypes;
import org.pnml.emf.ptnet.*;


public class CreateReadArcHandler extends CreateArcHandler {

    public CreateReadArcHandler() {
        super(PNMLModelTypes.READ_ARC);
    }

    @Override
    public String getLabel() { return "ReadArc"; }

    protected void setType(Arc arc){
        ToolInfo arcToolSpecifics = PtnetFactory.eINSTANCE.createToolInfo();
        arcToolSpecifics.setTool(PNMLModelTypes.DINEROS_TOOL_NAME);
        arcToolSpecifics.setVersion(PNMLModelTypes.DINEROS_VERSION);
        arcToolSpecifics.setType(PNMLModelTypes.READ_ARC_TYPE);
        arc.getToolspecific().add(arcToolSpecifics);
    }

}
